/*
  mcontrol - a MIDI controller software 

  control.C  -  main functions.
  Copyright (C) 2003-2004 Josep Andreu (Holborn)
  Author: Josep Andreu

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License
  as published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License (version 2) for more details.

  You should have received a copy of the GNU General Public License (version2)
  along with this program; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/



#include "global.h"
#include <stdio.h>
#include <string.h>
pthread_mutex_t mutex;
int Pexitprogram, vumvum, espera, programa, hubofile;
VumetrosIn vumi[2];
VumetrosOut vumo[2];



MCONTROL::MCONTROL ()
{

 int i,j,k;

  //inicio de variables
  propchan=16;
  forceCH = 0;
  espera = 0;
  sc = 0;
  seccion = 1;
  boton = 1;
  velo = 0;
  
  for (i= 0; i<= 199; i++)
   {
        strcpy(Controllers[i].name,"Empty");
        Controllers[i].min =0;
        Controllers[i].max =127;
        Controllers[i].type=1;
        Controllers[i].num=1;
        Controllers[i].cval=0;
        Controllers[i].prevnum=99;
        Controllers[i].prevval=127;
        Controllers[i].d1num=6;
        Controllers[i].d1min=0;
        Controllers[i].d1max=127;
        Controllers[i].d2num=38;
        Controllers[i].d2min=0;
        Controllers[i].d2max=127;
        Controllers[i].anum=0;
        Controllers[i].aonval=0;
        Controllers[i].sysexl=0;
        memset (Controllers[i].sysexm, 0 ,sizeof(Controllers[i].sysexm));
  }
  
     

  for (i = 0; i <= 24; i++)
    Cname[i] = 0;
  for (i = 0; i <= 256; i++)
    Comment[i] = 0;

  for (i=1; i<=12; i++)
    {
     for (j=1; j<=5; j++)
      {   
         Dcontrol[i][j].ON=0;
         Dcontrol[i][j].num=0;
      }
    }
  
  for (i=1; i<=5; i++) Bypass[i]=0;

// Inicia BanK

  for (j = 1; j <= 44; j++)
    {

 
      Banco[j].velo = 0;

 for (i=1; i<=12; i++)
     {
     for (k=1; k<=5; k++)
        {
         Banco[j].Dcontrol[i][k].ON=0;
         Banco[j].Dcontrol[i][k].num=0;
         }
     }
                                                     
  for (i=1; i<=5; i++) Banco[j].Bypass[i]=0;

      for (i = 0; i <= 24; i++)
	Banco[j].Cname[i] = 0;
      for (i = 0; i <= 256; i++)
	Banco[j].Comment[i] = 0;


    }



  //ALSA init
  snd_seq_open (&MidiInPuerto[1].midi_in, "default", SND_SEQ_OPEN_INPUT, 0);
  snd_seq_open (&MidiOutPuerto[1].midi_out, "default", SND_SEQ_OPEN_OUTPUT,
		  0);


  int alsaport = 0;
  char portname[50];
    sprintf (portname, "mcontrol IN");

      alsaport =
	snd_seq_create_simple_port (MidiInPuerto[1].midi_in, portname,
				    SND_SEQ_PORT_CAP_WRITE |
				    SND_SEQ_PORT_CAP_SUBS_WRITE,
				    SND_SEQ_PORT_TYPE_SYNTH);
    
    
      sprintf (portname, "mcontrol OUT");


      alsaport =
	snd_seq_create_simple_port (MidiOutPuerto[1].midi_out, portname,
				    SND_SEQ_PORT_CAP_READ |
				    SND_SEQ_PORT_CAP_SUBS_READ,
				    SND_SEQ_PORT_TYPE_SYNTH);

    




  FILE *fs;
  char temp[256];
  char nomfile[256];
  sprintf (nomfile, "%s%s", getenv ("HOME"), "/.mcontrol");
  if ((fs = fopen (nomfile, "r")) != NULL)
	{
	  
	      bzero (temp, sizeof (temp));
	      fgets (temp, sizeof temp, fs);
	      for (i = 0; i <= (int) strlen (temp) - 2; i++)
		MidiInPuerto[1].SetMidiIn[i] = temp[i];
	      MidiInPuerto[1].SMidiIn = MidiInPuerto[1].SetMidiIn;
	    
	      bzero (temp, sizeof (temp));
	      fgets (temp, sizeof temp, fs);
	      for (i = 0; i <= (int) strlen (temp) - 2; i++)
		MidiOutPuerto[1].SetMidiOut[i] = temp[i];
	      MidiOutPuerto[1].SMidiOut = MidiOutPuerto[1].SetMidiOut;
	    
              bzero(BankFilename, sizeof (BankFilename));
              bzero (temp, sizeof (temp));
              fgets (temp, sizeof temp, fs);
              if (strlen(temp)>2)
               {
                for (i = 0; i <= (int) strlen(temp) - 2; i++) BankFilename[i] = temp[i];
                loadbank(BankFilename);
               }

              bzero(PresetFilename, sizeof (BankFilename));
              bzero (temp, sizeof (temp));
              fgets (temp, sizeof temp, fs);
              if (strlen(temp)>2)
               {
                for (i = 0; i <= (int) strlen(temp) - 2; i++) PresetFilename[i] = temp[i];
                loadpreset(PresetFilename);
               }
 



	}
    

  espera = 1;


};

MCONTROL::~MCONTROL ()
{

  snd_seq_close (MidiInPuerto[1].midi_in);
  snd_seq_close (MidiOutPuerto[1].midi_out);

};


void
MCONTROL::nuevo ()
{
int i,j;


  for (i=1; i<=12; i++)
       {
            for (j=1; j<=5; j++)
                  {
                      Dcontrol[i][j].ON=0;
                      Dcontrol[i][j].num=0;
                  }
        }
                                              
  for (i=1; i<=5; i++) Bypass[i]=0;
                                                
  for (i = 0; i <= 24; i++)
    Cname[i] = 0;
  Combiname = Cname;
  for (i = 0; i <= 256; i++)
    Comment[i] = 0;
  Comentario = Comment;

};


int
MCONTROL::Calvalor(int min, int max, int value)
{

int i;

i = (int) (value * (max - min)) / 127;

return (i+min);


}


int MCONTROL::PB2CC(int value)
{
 int i;
 
 i = (int) (((value + 8192) * 127) / 16383);

 return (i);

};

int MCONTROL::CC2PB(int value)
{

unsigned int i;


i = ((value * 16383) / 127) - 8192;

return (i);


};


unsigned int MCONTROL::fCH(int canal)
{

if (forceCH > 0) return (forceCH -1);
return(canal);

};


void MCONTROL::parse_sysex(int num, int canal, int value)
{

int i,k,j ;

j = 0;
k = 0;


for (i=0; i < Controllers[num].sysexl; i++)
{


 sysx[k] = Controllers[num].sysexm[i];
 
  j = Controllers[num].sysexm[i];

  if ( j == 300)
  
      {
        i++;
        if (Controllers[num].sysexm[i] == 35) sysx[k] = canal;
        if (Controllers[num].sysexm[i] == 64) sysx[k] = value;
      }

  k++;
 


}


};

