/*
  mcontrol - a MIDI controller software

  global.h  -  Veriable and functions definitions.
  Copyright (C) 2003-2004 Josep Andreu (Holborn)
  Author: Josep Andreu

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License
  as published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License (version 2) for more details.

  You should have received a copy of the GNU General Public License (version2)
  along with this program; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/




#ifndef global_H
#define global_H
#include <pthread.h>
#include <alsa/asoundlib.h>



struct VumetrosIn
{
  int vumvum, ulvum;
};

struct VumetrosOut
{
  int uvo, uluvo;
};


extern pthread_mutex_t mutex;
extern int Pexitprogram, espera, programa, hubofile;
extern VumetrosIn vumi[2];
extern VumetrosOut vumo[2];




class MCONTROL
{



public:
  MCONTROL ();
  ~MCONTROL ();

  void midievents (int i);
  void enviocontrol (int canal, int param, int value);
  void enviopb(int canal, int value);
  void enviosysex(int canal, int num, int value);
  void panico ();
  void nuevo ();
  void savefile (char *filename);
  void loadfile (char *filename);
  void savebank (char *filename);
  void loadbank (char *filename);
  void loadpreset (char *filename);
  void savepreset (char *filename);
  void semipanico(int i);
  void procesa(int seccion, int canal, int value);
  void pevento(int num, int canal, int value);
  int Calvalor(int min,int max, int value);
  int PB2CC(int value); 
  int CC2PB(int value);
  void parse_sysex(int num, int canal, int value);
  unsigned int fCH (int canal);

  //parameters

  char *Combiname;
  char Cname[24];
  char *Comentario;
  char Comment[256];
  char temporal[16];
  unsigned char sysx[512];
  int sc;
  int seccion;
  int boton;
  unsigned int propchan;
  int forceCH;
  char BankFilename[128];
  char PresetFilename[128];

  int velo;


struct DataMcontroller
{
  char name[128];
  unsigned int type;
  unsigned int num;
  unsigned int cval;
  unsigned int min;
  unsigned int max;
  unsigned int prevnum;
  unsigned int prevval;
  unsigned int d1num;
  unsigned int d1min;
  unsigned int d1max;
  unsigned int d2num;
  unsigned int d2min;
  unsigned int d2max;
  unsigned int anum;
  unsigned int aonval;
  unsigned int sysexl;
  unsigned int sysexm[512];  

} Controllers[200];

int Bypass[6];


struct DatoControlProg
{
  int ON;
  int num;
} Dcontrol[13][7];


  struct PuertoMidiIn
  {
    int YOIN, SettingsIN;
    char *SMidiIn;
    char pMIDIIN[256];
    char SetMidiIn[40];
    int Ports;
    snd_seq_t *midi_in;
    unsigned int IN[16];
  }  MidiInPuerto[2];


  struct PuertoMidiOut
  {
    int YOOUT, SettingsOUT;
    char *SMidiOut;
    char SetMidiOut[40];
    int Ports;
    snd_seq_t *midi_out;
    unsigned int OUT[16];
    char pMIDIOUT[128];

  } MidiOutPuerto[2];






  struct DataBanco
  {
    int velo;
    unsigned int Bypass[6];
    DatoControlProg Dcontrol[13][7];
    char Cname[24];
    char Comment[256];
  } Banco[45];

  struct PMidiOut
  {
    int Client, Port;
    char Nombre[40], Info[40];
    const char *CName, *CInfo;

  } CPOMidiS[48];

  struct PMidiIn
  {
    int Client, Port;
    char Nombre[40], Info[40];
    const char *CName, *CInfo;

  }  CPIMidiS[48];

};


#endif

