/*
  mcontrol - a MIDI controllerr software 

  main.C  -  Main file of the controller.
  Copyright (C) 2003-2004 Josep Andreu (Holborn)
  Author: Josep Andreu

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License
  as published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License (version 2) for more details.

  You should have received a copy of the GNU General Public License (version2)
  along with this program; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/






#include <getopt.h>
#include <pthread.h>
#include "global.h"
#include "MCONTROL.h"
pthread_t thr1;




MCONTROL mcontrol;


void *
thread1 (void *arg)
{
  while (Pexitprogram == 0)
    mcontrol.midievents (1);
  return (0);
};

int main (int argc, char *argv[])

{



  fprintf (stderr,
	   "mcontrol v0.1.03 - Copyright (c) 2004 Josep Andreu (Holborn)\n");
  if (argc == 1)
    fprintf (stderr, "Try 'mcontrol --help' for command-line options.\n");

  
  struct option opts[] = {
    {"load", 2, NULL, 'l'},
    {"bank", 2, NULL, 'b'},
    {"help", 2, NULL, 'h'},
    {0, 0, 0, 0}
  };

  Pexitprogram = 0;
  hubofile = 0;

  opterr = 0;
  int option_index = 0, opt, exitwithhelp = 0;
  while (1)
    {
      opt = getopt_long (argc, argv, "l:b:h", opts, &option_index);
      char *optarguments = optarg;

      if (opt == -1)
	break;


      switch (opt)
	{
	case 'h':
	  exitwithhelp = 1;
	  break;
	case 'l':
	  if (optarguments != NULL)
	    {
              hubofile = 1;
	      mcontrol.loadfile (optarguments);
	      break;
	    }
	case 'b':
	  if (optarguments != NULL)
	    {
	      mcontrol.loadbank (optarguments);
	      break;
	    }


	};
    };

  if (exitwithhelp != 0)
    {
      fprintf (stderr, "Usage: mcontrol [OPTION]\n\n");
      fprintf (stderr,
	       "  -h ,     --help \t\t\t display command-line help and exit.\n");
      fprintf (stderr, "  -l File, --load=File \t\t\t loads single program.\n");
      fprintf (stderr, "  -b File, --bank=File \t\t\t loads bank of programs.\n");
      fprintf (stderr, "\n\n");
      return (0);
    };




  MCONTROLUI *mcontrolUI = new MCONTROLUI (&mcontrol);


  pthread_mutex_init (&mutex, NULL);
  pthread_create (&thr1, NULL, thread1, NULL);


  while (Pexitprogram == 0)
    {

      Fl::wait();

      if (vumi[1].vumvum != vumi[1].ulvum)
	mcontrolUI->VUI1->value (vumi[1].vumvum);

      if (vumo[1].uluvo != vumo[1].uvo)
	{
	  mcontrolUI->MO1->value (vumo[1].uvo);
	  vumo[1].uluvo = vumo[1].uvo;
	}
      if (programa != 0)
	{
	  mcontrolUI->PutCombi (programa);
	  programa = 0;
	}

    }


  pthread_mutex_destroy (&mutex);
  delete mcontrolUI;

};
