/*
  mcontrol - a MIDI controller software 

  midicFileIO.C  -  File I/O functions.
  Copyright (C) 2003-2004 Josep Andreu (Holborn)
  Author: Josep Andreu

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License
  as published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License (version 2) for more details.

  You should have received a copy of the GNU General Public License (version2)
  along with this program; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/

#include "global.h"


void
MCONTROL::savefile (char *filename)
{
  int i;
  FILE *fn;
  char buf[256];
  fn = fopen (filename, "w");

for (i=1; i<=12; i++)
        {
        
         bzero (buf, sizeof (buf));
sprintf (buf,"%d,%d,%d,%d,%d,",Dcontrol[i][1].ON,Dcontrol[i][2].ON,Dcontrol[i][3].ON,Dcontrol[i][4].ON,Dcontrol[i][5].ON);             
        fputs (buf, fn);
        bzero (buf, sizeof (buf));
sprintf (buf,"%d,%d,%d,%d,%d\n",Dcontrol[i][1].num,Dcontrol[i][2].num,Dcontrol[i][3].num,Dcontrol[i][4].num,Dcontrol[i][5].num);
        fputs (buf, fn);
        bzero (buf, sizeof (buf));
        }

        
sprintf (buf,"%d,%d,%d,%d,%d,%d\n",Bypass[1],Bypass[2],Bypass[3],Bypass[4],Bypass[5],velo);
        fputs (buf, fn);
        bzero (buf, sizeof (buf));
        
              
  for (i = 0; i <= 24; i++)
    buf[i] = Cname[i];
  fputs (buf, fn);
  bzero (buf, sizeof (buf));
  fputs ("\n", fn);
  for (i = 0; i <= 256; i++)
    buf[i] = Comment[i];
  fputs (buf, fn);
  bzero (buf, sizeof (buf));
  fputs ("\n", fn);

  fclose (fn);

};

void
MCONTROL::loadfile (char *filename)
{
  int i;
  int k = 1;
  FILE *fn;
  char buf[512];

  if ((fn = fopen (filename, "r")) == NULL)
    return;


for (i=1; i<=12; i++)
        {
      
         bzero (buf, sizeof (buf));
         fgets(buf, sizeof buf, fn);
         
sscanf (buf,"%d,%d,%d,%d,%d,%d,%d,%d,%d,%d",&Dcontrol[i][1].ON,&Dcontrol[i][2].ON,&Dcontrol[i][3].ON,&Dcontrol[i][4].ON,&Dcontrol[i][5].ON,&Dcontrol[i][1].num,&Dcontrol[i][2].num,&Dcontrol[i][3].num,&Dcontrol[i][4].num,&Dcontrol[i][5].num);
         
        } 
         bzero (buf, sizeof (buf));
         fgets(buf, sizeof buf, fn);
sscanf (buf,"%d,%d,%d,%d,%d,%d",&Bypass[1],&Bypass[2],&Bypass[3],&Bypass[4],&Bypass[5],&velo);
         
  bzero (Cname, sizeof (Cname));
  bzero (buf, sizeof (buf));

  fgets (buf, sizeof buf, fn);
  
  for (i = 0; i <= 24; i++)
  if (buf[i] > 20) Cname[i] = buf[i];
  Combiname = Cname;
  bzero (buf, sizeof (buf));
  bzero (Comment, sizeof (Comment));
  k = 0;

  

  while (fgets (buf, sizeof buf, fn) != NULL)
    {
      for (i = 0; i <= (int) strlen (buf); i++)
	Comment[i + k] = buf[i];
      k = k + strlen (buf);
    }
  Comentario = Comment;


  fclose (fn);
};

void
MCONTROL::loadbank (char *filename)
{

 int i;

 FILE *fs;
 
   
  if ((fs = fopen (filename, "rb")) != NULL)
      {
      
      while (!feof(fs))
              {
              i = fread(&Banco, sizeof(Banco),1,fs);
              }
                 fclose(fs);
       }
                           
                           
};



void
MCONTROL::savebank (char *filename)
{

FILE *fs;
  if ((fs = fopen (filename, "wb")) != NULL)
       {
              fwrite(&Banco, sizeof(Banco),1,fs);
              fclose(fs);
        }
                          
                          
};

void

MCONTROL::loadpreset (char *filename)
{
 int i;

 FILE *fs;
 
   
   if ((fs = fopen (filename, "rb")) != NULL)
      {
      
      while (!feof(fs))
             {
              i = fread(&Controllers, sizeof(Controllers),1,fs);
                
              }
                 fclose(fs);
       }
                           
                           



};

void

MCONTROL::savepreset (char *filename)
{

int i;


 FILE *fs;
  if ((fs = fopen (filename, "wb")) != NULL)
     {
       fwrite(&Controllers, sizeof(Controllers),1,fs);
       fclose(fs);
      }
                

};



