/*
  mcontrol - a MIDI controller software 

  midicMidiOut.C  -  MIDI Output functions.
  Copyright (C) 2003-2004 Josep Andreu (Holborn)
  Author: Josep Andreu

  This program is free software; you can redistribute it and/or modify
  it under the terms of version 2 of the GNU General Public License
  as published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License (version 2) for more details.

  You should have received a copy of the GNU General Public License (version2)
  along with this program; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/

#include "global.h"

void
MCONTROL::enviocontrol (int canal, int param, int value)
{
  
  snd_seq_event_t midievent;
  snd_seq_ev_clear (&midievent);


  snd_seq_ev_set_controller (&midievent,  canal, param, value);

  snd_seq_ev_set_subs (&midievent);
  snd_seq_ev_set_direct (&midievent);

  snd_seq_event_output_direct (MidiOutPuerto[1].midi_out, &midievent);

  vumo[1].uvo = value;    

};


void
MCONTROL::enviosysex(int canal, int num, int value)
{

  unsigned int dlen;
  
  

  memset(sysx, 0, sizeof(sysx));
  
  snd_seq_event_t midievent;

  snd_seq_ev_clear (&midievent);
  parse_sysex(num,canal,value);

  
  dlen = Controllers[num].sysexl -1;
    
  snd_seq_ev_set_sysex(&midievent, dlen, sysx);
      
  snd_seq_ev_set_subs (&midievent);
  snd_seq_ev_set_direct (&midievent);
        
  snd_seq_event_output_direct (MidiOutPuerto[1].midi_out, &midievent);
          
  vumo[1].uvo = value;
            
};



void
MCONTROL::enviopb (int canal, int value)
{

   snd_seq_event_t midievent;
   snd_seq_ev_clear (&midievent);
   
   
   snd_seq_ev_set_pitchbend (&midievent,  canal, value);
    
   snd_seq_ev_set_subs (&midievent);
   snd_seq_ev_set_direct (&midievent);
         
   snd_seq_event_output_direct (MidiOutPuerto[1].midi_out, &midievent);
           
   vumo[1].uvo = value;
             

};

void
MCONTROL::panico ()
{

  int i,j;
  snd_seq_event_t midievent;
  snd_seq_ev_clear (&midievent);

  for (i = 0; i <= 127; i++)
    {
      for (j = 0; j <= 15; j++)
	{
	  enviocontrol (j, 123,0);
	  snd_seq_ev_set_noteoff (&midievent, j, i, 80);
	  snd_seq_ev_set_subs (&midievent);
	  snd_seq_ev_set_direct (&midievent);
	  snd_seq_event_output_direct (MidiOutPuerto[1].midi_out,&midievent);
	}
    }

};


void
MCONTROL::procesa(int seccion, int canal, int value)
{

int i;

for (i=1; i<=12; i++)
      {
          if (Dcontrol[i][seccion].ON)
                 {
                   pevento(Dcontrol[i][seccion].num,canal,value);
                 }  
      }

};


void
MCONTROL::pevento(int num, int canal, int value)
{

int eltipo;

eltipo = Controllers[num].type;
  
 switch (eltipo)

   {
       case 1:
                
       enviocontrol(canal, Controllers[num].num, Calvalor(Controllers[num].min,Controllers[num].max,value));
       break;
       
       
       case 2:
       enviocontrol(canal, Controllers[num].num, Controllers[num].cval);
       enviocontrol(canal, Controllers[num].prevnum, Controllers[num].prevval);
       enviocontrol(canal, Controllers[num].d1num, Calvalor(Controllers[num].d1min,Controllers[num].d1max,value));
       enviocontrol(canal, Controllers[num].d2num, Calvalor(Controllers[num].d2min,Controllers[num].d2max,value));
       break;
       
       case 3:
       enviocontrol(canal, Controllers[num].num, Controllers[num].cval);
       enviocontrol(canal, Controllers[num].prevnum, Controllers[num].prevval);
       enviocontrol(canal, Controllers[num].d1num, Calvalor(Controllers[num].d1min,Controllers[num].d1max,value));
       break;               

       case 4:
       enviocontrol(canal, Controllers[num].anum, Controllers[num].aonval);
       enviocontrol(canal, Controllers[num].num, Calvalor(Controllers[num].min,Controllers[num].max,value));
       break;

       case 5:
       enviopb(canal, CC2PB(Calvalor(Controllers[num].min,Controllers[num].max,value)));
       break;       

       case 6:
       enviosysex(canal,num,Calvalor(Controllers[num].min,Controllers[num].max,value));
       break;

       
       
  }

};



